#define BCD_TRUE 0
#define BCD_FALSE 1
#define BCD_FAIL 0
#define BCD_SUCCEED 1
#define BCD_XB_METHOD 0
#define BCD_EL_METHOD 1
#define BCD_XB_METHOD_NAME "Xie-Beerel algorithm"
#define BCD_EL_METHOD_NAME "Emerson-Lei algorithm"
#define BCD_BACKWARD_ONLY 1     /* follow scc */
#define BCD_BACKWARD_FORWARD 2  /* follow scc */
#define BCD_RANDOM 0
#define BCD_DETERMINISTIC 1

extern int bcdHamming;
extern int bcdVerbose;
extern int bcdRecursionType;
extern int bcdMethod;
extern int bcdMachineFail;
extern int bcdBddCacheFlush;
extern int bcdBCgeneration;
extern int bcdFindAll;
extern char *bcdOutputFileName;
extern FILE *bcdOutputFile;
extern int bcdNumCS;
extern sccMddList *bcdSccList;
extern int bcdRestrict;

extern int bcd_XB(Fsm_Fsm_t *fsm, mdd_t *reachable, sccMddList *csList);
extern int bcd_EL(Fsm_Fsm_t *fsm, mdd_t *reachable, sccMddList *csList);
extern sccMddList *bcdReadCycleSets();
extern void bcd_PrintResult(long, int);
extern int bcd_XB_recur_backwardOnly(Fsm_Fsm_t *fsm, mdd_t *, mdd_t *, mdd_t*, sccMddList *, int*);
extern sccMddList *bcdReadCycleSets(Fsm_Fsm_t *fsm);
extern double bcd_numStates(Fsm_Fsm_t *, mdd_t *);
extern sccMddList *bcd_cmplList(Fsm_Fsm_t *fsm, mdd_t *space, sccMddList *list);
extern int bcd_mddsAreNotEqual(mdd_t *d1, mdd_t *d2);
extern char *bcd_strSave(char *);

extern mdd_t * bcd_Compute_A_Maximal_Hamming_Distance_Minterm( 
  mdd_t *aSet, mdd_t *aMinterm, array_t *Support, mdd_manager *mddMgr);

extern mdd_t * bcd_Compute_A_Maximal_Hamming_Distance_State( 
  mdd_t *states, mdd_t *from_state, Fsm_Fsm_t *modelFsm);
