#include <float.h>
#include <stdlib.h>
#include <math.h>
#include "fsm.h"
#include "bdd.h"
#include "sccInt.h"
#include "bcdInt.h"

extern double uniform();

sccMddList *bcdReadCycleSets(Fsm_Fsm_t *fsm) 
{
	int id, numSCC, i;
	sccMddList *curs, *res, *lastCurs, *newCurs;
	mdd_t *x;
	/*
	fprintf(vis_stderr, "bcdReadCycleSets not implemented yet. Return NULL.");
	return NULL;
	*/

	/* currently return all scc's of the machine */
	id = 0;
	res = NULL;
	curs = sccInternalSCCList;
	lastCurs = NULL;
	numSCC = 0;
	while (curs) {
		numSCC++;
		newCurs = (sccMddList *)calloc(1,sizeof(sccMddList));
		newCurs->val = mdd_dup(curs->val);

if (bcdVerbose>0) {
		newCurs->size = bcd_numStates(fsm, curs->val);
}
		newCurs->id = id++;
		if (lastCurs)
			lastCurs->next = newCurs;
		lastCurs = newCurs;
		if (res == NULL)
			res = lastCurs;
		curs = curs->next;
	}
	curs = sccExternalSCCList;
	while (curs) {
		numSCC++;
		newCurs = (sccMddList *)calloc(1,sizeof(sccMddList));
		newCurs->val = mdd_dup(curs->val);

if(bcdVerbose) {
		newCurs->size = bcd_numStates(fsm, newCurs->val);
}
		newCurs->id = id++;
		if (lastCurs)
			lastCurs->next = newCurs;
		lastCurs = newCurs;
		if  (res == NULL)
			res = lastCurs;
		curs = curs->next;
	}

	if (bcdMachineFail == BCD_TRUE) {
		if (res->next) {
			/* take out one scc from the cycle set */
			if (bcdBCgeneration == BCD_RANDOM)
				i = uniform()*numSCC;
			else
				i = 0;
			lastCurs = NULL;
			curs = res;
			while (i) {
				lastCurs = curs;
				curs = curs->next;
				i--;
			}
			if (lastCurs)
				lastCurs->next = curs->next;
			else
				res = res->next;
if (bcdVerbose>0) {
			fprintf(vis_stderr, 
			"take %d-th scc (%g states) out of the scc sets to create the cycle sets.\n", 
			curs->id, curs->size);
}
			mdd_free(curs->val);
			free(curs);
		} else {
			/* take one state out of the only scc of the machine
			   which is chosen to be the only cycle set */
			x = scc_TakeAState(fsm, res->val); 
			res->val = scc_MddAndDestroy(res->val, x, 1, 0, 1, 1);
		}
	}
	bcdNumCS = 0;
	for (curs = res; curs; curs = curs->next)
		bcdNumCS++;
	return res;
}

double uniform() {return (double)drand48();}
