#ifndef SCCINT_H
#define SCCINT_H

extern mdd_t *scc_mdd_one(Fsm_Fsm_t *fsm);
extern mdd_t *scc_mdd_zero(Fsm_Fsm_t *fsm);
extern mdd_t *scc_MddAndDestroy(mdd_t *a, mdd_t *b,
				boolean phase_a, boolean phase_b,
				boolean destory_a, boolean destory_b);
extern mdd_t *scc_MddOrDestroy(mdd_t *a, mdd_t *b,
				boolean phase_a, boolean phase_b,
				boolean destory_a, boolean destory_b);
extern int scc_Decompose(Fsm_Fsm_t *fsm, mdd_t *stateSpace, int recordSCC);
extern mdd_t *scc_ForwardReachableStates(Fsm_Fsm_t *fsm, mdd_t *initialStates, 
		mdd_t *bound);
extern mdd_t *scc_BackwardReachableStates(Fsm_Fsm_t *fsm, mdd_t *initialStates,
		mdd_t *bound);
extern void scc_PrintResult(long elapsetime, int method);

extern int scc_Decompose_TC(Fsm_Fsm_t *fsm, long *initialTime, long *finalTime);
extern mdd_t *scc_TakeAState(Fsm_Fsm_t *fsm, mdd_t *S);
extern mdd_t *scc_FwdEscapingImage(Fsm_Fsm_t *, mdd_t*);
extern mdd_t *scc_NonSCCiteration(Fsm_Fsm_t *, mdd_t *, mdd_t *);
extern mdd_t *scc_RestrictedBwdImage(Fsm_Fsm_t *, mdd_t *, mdd_t *);
extern mdd_t *scc_RestrictedFwdImage(Fsm_Fsm_t *, mdd_t *, mdd_t *);
extern int scc_ReportSCC(Fsm_Fsm_t *, mdd_t *, int, int, int);

#define NONSCC   		0
#define INTERNAL 		1
#define TERMINAL 		2
#define BACKWARD_ONLY 		1
#define BACKWARD_FORWARD 	2
#define USC_SCC_METHOD 		0
#define UCB_SCC_METHOD 		1

#define BACKWARD 0
#define FORWARD 1

extern int sccVerbose;
extern int sccRecursionType;
extern int sccMethod;


typedef struct _sccMddList {
    int id;
    double size;
    mdd_t *val;
    struct _sccMddList *next;
} sccMddList;

extern sccMddList *sccInternalSCCList, *sccExternalSCCList;
extern void scc_addSCCList(sccMddList **list, mdd_t *states);
#endif
